unit CompressWaveLib;

interface

uses Windows,Classes,Math,SysUtils,DDSD,HuffLib,mmsystem;

const PW_MAXVOLUME = $FFFFFFF;  //Ȃł
const PW_MAXCHANNEL= 7;         //ő`l

type TCWPlayState = (CWEmpty,CWStop,CWPlay,CWLoop);

//kWAVEt@Cwb_
type WAVEDATAHED = record
  //RIFF `N
  RiffHed  : array[0..3] of char;
  RiffSize : DWORD;
  WaveHed  : array[0..3] of char;
  //FMT(Format) `N
  FmtHed   : array[0..3] of char;
  FmtSize  : DWORD;
  Format   : WORD;
  Channel  : WORD;
  Sample   : DWORD;
  Avg      : DWORD;
  BlockSize: WORD;
  Bit      : WORD;
  //f[^`N
  DataHed  : array[0..3] of char;
  DataSize : DWORD;
end;

//Ǝk`t@Cwb_
type PRESSWAVEDATAHED = record
  //RIFF`N
  HedChar : array[0..7] of char;     // 'CmpWave'
  Channel : DWORD;                   // 2(STEREO) / 1(MONO)
  Sample  : DWORD;                   // 44100Hz / 22050Hz
  Bit     : DWORD;                   // 16bit
  Tbl     : array[0..255] of Integer;// ϊe[ul
  UnPressSize : Int64;               // 𓀎̃f[^TCY
  LoopStart,LoopEnd : Int64;         // [vJnʒuEIʒu
  LoopCount : BYTE;                  // [v
  MusicTitle : string[127];          // Ȗ
  MusicArtist: string[127];          // Ȏ
end;

//ݗp
type TLRWRITEBUFFER = record
  RBuf,LBuf : SmallInt;
end;

//--------------------------------------------------------------------------
//kf[^NX
type TCompressWaveData = class
  private
    //_OtOi_O̓tOj
    NowRendering : Boolean;
    //Đp̃tO
    Faa1,Faa2,Fvv1,Fvv2 : Integer;
    Fvolume,Ffade,FSetVolume : Integer;
    FEndLoop: Boolean;
    FLoop   : Integer;
    FPlay   : Boolean;
    FWavePosition   : Int64;
    FWaveLength     : Int64;
    //22050kHzpӂ炮
    LBackBuf,RBackBuf : Integer;
    //p
    PosData : THuffPositionData;
    LPFaa1,LPFaa2,LPFvv1,LPFvv2 : Integer;
    //ÍR[h
    CipherCode : DWORD;
    //͂ӂ͂ӂ͂ӂ܂
    RH : THuff;
    procedure   GetLoopState;
    procedure   SetLoopState;
  public
    Data : TMemoryStream;
    Hed  : PRESSWAVEDATAHED;
    //JEgtO
    UseTbl : array[0..255] of DWORD;   // etO̎gppx
    
    constructor Create;
    procedure   Free;
    procedure   MakeTable(Vol : Single);
    procedure   PressFromStream(ss: TMemoryStream);
    procedure   PressFromFile(filename : string);
    procedure   UnPressToStream(var ss : TmemoryStream);
    function    Rendering(buf : Pointer; Len : DWORD) : Boolean;
    procedure   SaveToFile(filename : string);
    procedure   SaveToStream(var ss : TmemoryStream);
    function    LoadFromStream(ss : TmemoryStream):Boolean;
    function    LoadFromFile(filename : string):Boolean;
    function    UnPressToDDSD(QS : TDDSD) : TDDSDWavedata;
    function    UnPressToDDSD3D(QS : TDDSD) : TDDSDWave3D;
    procedure   GetHistGraph(ss : TMemoryStream; Smp,Cha : Integer);
    procedure   HedUpdata;
    procedure   SetCipherCode(Num:DWORD);
    //n
    procedure   Play(loop:Boolean);
    procedure   Stop;
    procedure   Previous;
    procedure   Pause;
    procedure   SetVolume(vol : single; fade : single);
    function    GetVolume : single;
    function    GetSetVolume : Single;
    function    GetFade : single;
    function    GetPlayTime : Single;
    function    GetTotalTime: Single;
    function    GetPlayState : TCWPlayState;
end;

//--------------------------------------------------------------------------
//kf[^vC[NX
type TCompressWavePlayer = class
  private
    NowRendering : Boolean;
    FMusic : array[0..PW_MAXCHANNEL] of TCompressWaveData;  //ȃf[^(nil̏ꍇ͖o^)
    FBuf   : array[0..PW_MAXCHANNEL] of TMemoryStream;      //ƗpWJobt@
    FMVolume,FMFade,FMSetVolume : Integer;
    RefreshTime : int64;
  public
    PrimaryBuffer : TMemoryStream;
    BufferSize  : DWORD;
    constructor Create;
    procedure   Free;
    procedure   SetBufferSize(len : DWORD);
    procedure   Load(ch : Integer; Music : TCompressWaveData);
    procedure   SetVolume(ch : Integer; vol : single; fade : single);
    procedure   Stop(ch : Integer);
    procedure   Previous(ch : Integer);
    procedure   pause(ch : Integer);
    procedure   Play(ch : Integer; loop:Boolean);
    procedure   Swap(ch1,ch2 : Integer);
    procedure   Init;
    procedure   Rendering;
    procedure   SetMasterVolume(vol : single; fade : single);
    function    Buffer : Pointer;
    function    GetVolume(ch : Integer) : single;
    function    GetSetVolume(ch:Integer):single;
    function    GetFade(ch : Integer) : single;
    function    GetPlayTime(ch : Integer) : Single;
    function    GetTotalTime(ch : Integer) : Single;
    function    GetTitle(ch : Integer) : string;
    function    GetArtist(ch : Integer) : String;
    function    GetMasterFade: single;
    function    GetMasterVolume: single;
    function    GetPlayState(ch:Integer):TCWPlayState;
    function    GetReflectTime : Integer;
end;

//------------------------------------------------------------------------------
//wp[֐
function CWav_LoadWave(filename:String; QS:TDDSD) : TDDSDWavedata;
function CWav_LoadWave3D(filename:String; QS:TDDSD) : TDDSDWave3D;
function CWav_LoadWaveFromStream(ms:TMemoryStream; QS:TDDSD) : TDDSDWaveData;
function CWav_LoadWave3DFromStream(ms:TMemoryStream; QS:TDDSD) : TDDSDWave3D;

implementation

//--------------------------------------------------------------------------
//wp[֐
function CWav_LoadWaveFromStream(ms:TMemoryStream; QS:TDDSD) : TDDSDWaveData;
var
  cw : TCompressWaveData;
  buf : TDDSDWavedata;
begin
  result := nil;
  if (QS = nil)then exit;
  if (ms = nil)then exit;
  cw := TCompressWaveData.Create;
  cw.LoadFromStream(ms);
  buf := cw.UnPressToDDSD(QS);
  cw.Free;
  result := buf;
end;

function CWav_LoadWave3DFromStream(ms:TMemoryStream; QS:TDDSD) : TDDSDWave3D;
var
  cw : TCompressWaveData;
  buf : TDDSDWave3D;
begin
  result := nil;
  if (QS = nil)then exit;
  if (ms = nil)then exit;
  cw := TCompressWaveData.Create;
  cw.LoadFromStream(ms);
  buf := cw.UnPressToDDSD3D(QS);
  cw.Free;
  result := buf;
end;

function CWav_LoadWave(filename:String; QS:TDDSD) : TDDSDWavedata;
var
  ms : TMemoryStream;
  Buf: TDDSDWaveData;
begin
  result := nil;
  if (QS = nil)then exit;
  if (FileExists(filename) = FALSE)then exit;
  ms := TMemoryStream.Create;
  ms.LoadFromFile(FileName);
  Buf := CWav_LoadWaveFromStream(ms,QS);
  ms.Free;
  result := buf;
end;

function CWav_LoadWave3D(filename:String; QS:TDDSD) : TDDSDWave3D;
var
  ms : TMemoryStream;
  Buf: TDDSDWave3D;
begin
  result := nil;
  if (QS = nil)then exit;
  if (FileExists(filename) = FALSE)then exit;
  ms := TMemoryStream.Create;
  ms.LoadFromFile(FileName);
  Buf := CWav_LoadWave3DFromStream(ms,QS);
  ms.Free;
  result := buf;
end;

//============================================================================
{ TCompressWaveData }
//-----------------------------------------------------------
//
constructor TCompressWaveData.Create;
begin
  Data := nil;
  RH := nil;
  FWavePosition := 0;
  FWaveLength   := 0;
  Fvolume := PW_MAXVOLUME;
  FSetVolume := PW_MAXVOLUME;
  Ffade   := 0;
  FEndLoop:= FALSE;
  FPlay   := FALSE;
  NowRendering := FALSE;
  SetCipherCode(0);
end;
//-----------------------------------------------------------
//
procedure TCompressWaveData.Free;
begin
  //
  While(NowRendering) do;
  //
  if (RH   <> nil)then RH.Free;
  if (Data <> nil)then Data.Free;
  Destroy;
end;
//-----------------------------------------------------------
//WAVEf[^ɓWJăXg[ɏo
procedure TCompressWaveData.UnPressToStream(var ss: TmemoryStream);
var
  dHed : WAVEDATAHED;
  aaa : PBYTE;
begin
  if (data = nil)then exit;
  //WAVEwb_𐶐
  Data.Position := sizeof(PRESSWAVEDATAHED);
  dHed.RiffHed := 'RIFF';
  dHed.RiffSize:= Hed.UnPressSize + sizeof(WAVEDATAHED) - 8;
  dHed.WaveHed := 'WAVE';
  dHed.FmtHed  := 'fmt ';
  dHed.FmtSize := 16;
  dHed.Format  := 1;
  dHed.Channel := 2;
  dHed.Sample  := 44100;
  dHed.Avg     := 44100*2*2;
  dHed.BlockSize := 2*2;
  dHed.Bit     := 16;
  dHed.DataHed := 'data';
  dHed.DataSize:= Hed.UnPressSize;
  //WAVEwb_
  if (ss <> nil)then ss.Free;
  ss := TmemoryStream.Create;
  ss.Size := Hed.UnPressSize + sizeof(WAVEDATAHED);
  ss.Write(dHed,sizeof(WAVEDATAHED));
  ss.Position := 0;
  //WAVEɕ
  Stop;
  aaa := ss.Memory;
  inc(aaa,sizeof(WAVEDATAHED));
  Play(FALSE);
  Rendering(aaa,Hed.UnPressSize);
  Stop;
end;
//-----------------------------------------------------------
//Xg[Ɋi[ꂽWAVEf[^k
procedure TCompressWaveData.PressFromStream(ss: TMemoryStream);
var
  sHed : WAVEDATAHED;
  buf1,buf2 : SmallInt;
  Lvol,Rvol,LFlg,RFlg : Integer;
  i,j,aaa,bbb : Integer;
  fs : TFileStream;
  ATblMin,ATblMax : array[0..255] of Integer;
  PressLength : Integer;
  smp,Cha : Integer;
  WH : THuff;

  procedure ReadWave(var x1,x2 : SmallInt);
  var
    aa1,aa2,aa3,aa4 : SmallInt;
  begin
    if (smp = 44100)then
      if (Cha = 2)then
      begin
        ss.Read(x1,2);          //44100 / STEREO
        ss.Read(x2,2);
      end
      else
      begin
        ss.Read(x1,2);          //44100 / MONO
        ss.Read(x2,2);
        x1 := (x1 + x2 ) div 2;
        x2 := x1;
      end;
    if (smp = 22050)then
      if (Cha = 2)then
      begin
        ss.Read(aa1,2);         //22050 / STEREO
        ss.Read(aa2,2);
        ss.Read(aa3,2);
        ss.Read(aa4,2);
        x1 := (aa1 + aa3) div 2;
        x2 := (aa2 + aa4) div 2;
      end
      else
      begin
        ss.Read(aa1,2);         //22050 / MONO
        ss.Read(aa2,2);
        ss.Read(aa3,2);
        ss.Read(aa4,2);
        x1 := (aa1 + aa3 + aa2 + aa4) div 4;
        x2 := x1;
      end;
  end;
  procedure WritePress(x1,x2 : Integer);
  begin
    if (Cha = 2)then
    begin                       //STEREO
      WH.Write(x1);
      WH.Write(x2);
    end
    else
    begin                       //MONO
      WH.Write(x1);
    end;
  end;

begin
  if (ss = nil)then exit;
  //wb_`FbN݁i܂Ă邩Hj
  Hed.HedChar := 'CmpWave';
  Cha := Hed.Channel;
  Smp := Hed.Sample;
  if ((Cha <> 1    )and(Cha <> 2    ))then exit;
  if ((Smp <> 22050)and(Smp <> 44100))then exit;
  Hed.Bit     := 16;
  //WAVEopxqXgO擾
  GetHistGraph(ss,smp,cha);
  //WAVEwb_擾
  ss.Position := 0;
  ss.Read(sHed,sizeof(WAVEDATAHED));
  //Hed.UnPressSize := sHed.DataSize;
  Hed.UnPressSize := ss.Size - sizeof(WAVEDATAHED);
  //Ɨpobt@̊m
  fs := TFileStream.Create('WaveTemp.dat',fmCreate);
  //te[u
  aaa := 0;
  bbb := 0;
  for i:=0 to 127 do
  begin
    // +
    ATblMin[i*2+0] := aaa;
    ATblMax[i*2+0] := (Hed.tbl[i*2+0] + Hed.tbl[min(i*2+2,254)]) div 2;
    // -
    ATblMax[i*2+1] := bbb;
    ATblMin[i*2+1] := (Hed.tbl[i*2+1] + Hed.tbl[min(i*2+3,255)]) div 2;
    //ǑvZʂێ
    aaa := ATblMax[i*2+0];
    bbb := ATblMin[i*2+1];
  end;
  //PRESSWAVEwb_̕`
  fs.Write(Hed,sizeof(PRESSWAVEDATAHED));
  //nt}NX𐶐
  WH := THuff.Create(fs);
  WH.SetCipherCode(CipherCode);
  WH.BeginWrite(UseTbl);
  //O
  Fvv1 := 0;
  Faa1 := 0;
  Fvv2 := 0;
  Faa2 := 0;
  LBackBuf := 0;
  RBackBuf := 0;
  LFlg := 0;
  RFlg := 0;
  //
  if (smp = 44100)then PressLength := sHed.DataSize div 4 - 1
                  else PressLength := sHed.DataSize div 8 - 1;
  for i:=0 to PressLength - 1 do   //size
  begin
    //f[^ǂݍ
    ReadWave(buf1,buf2);
    RVol := buf1;
    LVol := buf2;
    // 16Bit  5Bit
    //R Volume
    aaa := RVol - (Fvv1+Faa1);
    for j:=0 to 255 do
      if ((aaa >= ATblMin[j])and(aaa <= ATblMax[j]))then
      begin
        RFlg := j;
        Faa1 := Faa1 + Hed.tbl[RFlg];
        Fvv1 := Fvv1 + Faa1;
        break;
      end;
    //L Volume
    aaa := LVol - (Fvv2+Faa2);
    for j:=0 to 255 do
      if ((aaa >= ATblMin[j])and(aaa <= ATblMax[j]))then
      begin
        LFlg := j;
        Faa2 := Faa2 + Hed.tbl[LFlg];
        Fvv2 := Fvv2 + Faa2;
        break;
      end;
    //
    WritePress(RFlg,LFlg);
    //臒lvZ
    if (fvv1 > +32760)then
      begin fvv1 := +32760; Faa1 := 0; end;
    if (fvv1 < -32760)then
      begin fvv1 := -32760; Faa1 := 0; end;
    if (fvv2 > +32760)then
      begin fvv2 := +32760; Faa2 := 0; end;
    if (fvv2 < -32760)then
      begin fvv2 := -32760; Faa2 := 0; end;
  end;
  //nt}I
  WH.Free;
  //FileStreamiƗpjTMemoryStream
  if (Data <> nil)then Data.Free;
  Data := TMemoryStream.Create;
  data.SetSize(fs.Size);
  data.CopyFrom(fs,0);
  fs.Free;
  //yf[^̒ƍĐʒuZbg
  FWaveLength  := Hed.UnPressSize;
  FWavePosition:= 0;
  Data.Position := sizeof(PRESSWAVEDATAHED);
  if (RH <> nil)then RH.Free;
  RH := THuff.Create(Data);
  RH.SetCipherCode(CipherCode);
  RH.BeginRead;
  Stop;
end;
//-----------------------------------------------------------
//WAVEf[^e[ȕopxԂ
procedure TCompressWaveData.GetHistGraph(ss: TMemoryStream; smp,Cha : Integer);
var
  sHed : WAVEDATAHED;
  buf1,buf2 : SmallInt;
  Lvol,Rvol,Lflg,Rflg : Integer;
  i,j,aaa,bbb : Integer;
  ATblMin,ATblMax : array[0..255] of Integer;
  PressLength : Integer;

  procedure ReadWave(var x1,x2 : SmallInt);
  var
    aa1,aa2,aa3,aa4 : SmallInt;
  begin
    if (smp = 44100)then
      if (Cha = 2)then
      begin
        ss.Read(x1,2);          //44100 / STEREO
        ss.Read(x2,2);
      end
      else
      begin
        ss.Read(x1,2);          //44100 / MONO
        ss.Read(x2,2);
        x1 := (x1 + x2) div 2;
        x2 := x1;
      end;
    if (smp = 22050)then
      if (Cha = 2)then
      begin
        ss.Read(aa1,2);         //22050 / STEREO
        ss.Read(aa2,2);
        ss.Read(aa3,2);
        ss.Read(aa4,2);
        x1 := (aa1 + aa3) div 2;
        x2 := (aa2 + aa4) div 2;
      end
      else
      begin
        ss.Read(aa1,2);         //22050 / MONO
        ss.Read(aa2,2);
        ss.Read(aa3,2);
        ss.Read(aa4,2);
        x1 := (aa1 + aa3 + aa2 + aa4) div 4;
        x2 := x1;
      end;
  end;
begin
  if (ss = nil)then exit;
  //WAVEwb_擾
  ss.Position := 0;
  ss.Read(sHed,sizeof(WAVEDATAHED));
  //te[u
  aaa := 0;
  bbb := 0;
  for i:=0 to 127 do
  begin
    // +
    ATblMin[i*2+0] := aaa;
    ATblMax[i*2+0] := (Hed.tbl[i*2+0] + Hed.tbl[min(i*2+2,254)]) div 2;
    // -
    ATblMax[i*2+1] := bbb;
    ATblMin[i*2+1] := (Hed.tbl[i*2+1] + Hed.tbl[min(i*2+3,255)]) div 2;
    //ǑvZʂێ
    aaa := ATblMax[i*2+0];
    bbb := ATblMin[i*2+1];
  end;
  //ϊe[ugp̎Zop
  for i:=0 to 255 do UseTbl[i] := 0;
  //O
  Fvv1 := 0;
  Faa1 := 0;
  Fvv2 := 0;
  Faa2 := 0;
  LBackBuf := 0;
  RBackBuf := 0;
  LFlg := 0;
  RFlg := 0;
  //
  if (smp = 44100)then PressLength := sHed.DataSize div 4 - 1
                  else PressLength := sHed.DataSize div 8 - 1;
  for i:=0 to PressLength - 1 do   //size
  begin
    ReadWave(buf1,buf2);
    RVol := buf1;
    LVol := buf2;
    // 16Bit  5Bit
    // R Volume
    aaa := RVol - (Fvv1+Faa1);
    for j:=0 to 255 do
      if ((aaa >= ATblMin[j])and(aaa <= ATblMax[j]))then
      begin
        RFlg := j;
        Faa1 := Faa1 + Hed.tbl[RFlg];
        Fvv1 := Fvv1 + Faa1;
        break;
      end;
    // L Volume
    aaa := LVol - (Fvv2+Faa2);
    for j:=0 to 255 do
      if ((aaa >= ATblMin[j])and(aaa <= ATblMax[j]))then
      begin
        LFlg := j;
        Faa2 := Faa2 + Hed.tbl[LFlg];
        Fvv2 := Fvv2 + Faa2;
        break;
      end;
    //o񐔂Ԃ
    inc(UseTbl[RFlg]);
    inc(UseTbl[LFlg]);
    //臒lvZ
    if (fvv1 > +32760)then
      begin fvv1 := +32760; Faa1 := 0; end;
    if (fvv1 < -32760)then
      begin fvv1 := -32760; Faa1 := 0; end;
    if (fvv2 > +32760)then
      begin fvv2 := +32760; Faa2 := 0; end;
    if (fvv2 < -32760)then
      begin fvv2 := -32760; Faa2 := 0; end;
  end;
  ss.Position := 0;
  Stop;
end;
//-----------------------------------------------------------
//w肳ꂽobt@44100/16Bit/STEREOŔg`o͂܂
function TCompressWaveData.Rendering(buf: Pointer; Len: DWORD) : Boolean;
var
  RFlg,LFlg,RVol,LVol : Integer;
  i,aaa : Integer;
  buf1 : ^TLRWRITEBUFFER;
  PressLength,WaveStep : Integer;

  procedure ReadPress;
  begin
    if (Hed.Channel = 2)then
    begin
      RFlg := RH.Read;                 //STEREO
      LFlg := RH.Read;
    end
    else
    begin
      RFlg := RH.Read;                 //MONO
      LFlg := RFlg;
    end;
  end;
  procedure WriteWave;
  var
    bbb : TLRWRITEBUFFER;
  begin
    if (Hed.Sample = 44100)then
    begin                             //44100 STEREO/MONO
      bbb.RBuf := RVol;
      bbb.LBuf := LVol;
      buf1^ := bbb;
      inc(buf1);
    end;
    if (Hed.Sample = 22050)then
    begin                             //22050 STEREO/MONO
      bbb.RBuf := (RBackBuf + RVol) div 2;
      bbb.LBuf := (LBackBuf + LVol) div 2;
      buf1^ := bbb;
      inc(buf1);
      bbb.RBuf := RVol;
      bbb.LBuf := LVol;
      buf1^ := bbb;
      inc(buf1);
      RBackBuf := RVol;
      LBackBuf := LVol;
    end;
  end;
begin
  NowRendering := TRUE;
  result := FALSE;
  if (data = nil)then
  begin
    NowRendering := FALSE;
    exit;
  end;
  //tF[hAEgċȒ~
  if ((Fvolume < 1)and(FSetVolume < 1)) then FPlay := FALSE;
  //if (abs(FSetVolume - FVolume) < Ffade)then FPlay := FALSE;
  //FPlayivCtOjĂȂ߂Ƃ
  if (FPlay = FALSE)then
  begin
    NowRendering := FALSE;
    exit;
  end;
  //O
  RVol := Fvv1;
  LVol := Fvv2;
  if (Hed.Sample = 44100)then WaveStep := 4
                         else WaveStep := 8;
  PressLength := Integer(len) div WaveStep;
  //WJ
  buf1 := buf;
  for i:=0 to PressLength - 1 do
  begin
    //zH
    if (FWavePosition > FWaveLength)then
      if (FEndLoop = TRUE)then
      begin         //[vĐH
        Previous;
      end
      else
      begin         //[vĐȂꍇ
        FPlay := FALSE;
        exit;
      end;
    //[v֌W
    if (Hed.LoopCount > FLoop)then
    begin
      //[vJnʒuAtOԂێ
      //shr 3 8oCgACgɂ킹
      if ((Hed.LoopStart shr 3) = (FWavePosition shr 3))then GetLoopState;
      //[vIʒuɒBĂ烋[vB
      if ((Hed.LoopEnd shr 3) = (FWavePosition shr 3))then
      begin
        if (Hed.LoopCount <> 255)then inc(FLoop);
        SetLoopState;
      end;
    end;
    //ǂݍ
    ReadPress;
    Faa1 := Faa1 + Hed.tbl[RFlg];
    Faa2 := Faa2 + Hed.tbl[LFlg];
    Fvv1 := Fvv1 + Faa1;
    Fvv2 := Fvv2 + Faa2;
    //ʒ
    aaa := FSetVolume - FVolume;
    if (abs(aaa) < Ffade)then
      FVolume := FSetVolume
    else
      if (aaa > 0)then FVolume := FVolume + Ffade
                  else FVolume := FVolume - Ffade;
    //臒lvZiOverFloŵŁj
    if (fvv1 > +32760)then
      begin fvv1 := +32760; Faa1 := 0; end;
    if (fvv1 < -32760)then
      begin fvv1 := -32760; Faa1 := 0; end;
    if (fvv2 > +32760)then
      begin fvv2 := +32760; Faa2 := 0; end;
    if (fvv2 < -32760)then
      begin fvv2 := -32760; Faa2 := 0; end;
    aaa := (FVolume shr 20);
    RVol := Fvv1 * aaa div 256;
    LVol := Fvv2 * aaa div 256;
    //obt@ɓWJ
    WriteWave;
    //Đʒui܂
    inc(FWavePosition,WaveStep);
  end;
  //]vZ
  //obt@̒ɂĂ͗]肪ꍇ
  //:44100 / 4 = 11025...OK    44100 / 8 = 5512.5...NG
  //܂肪ꍇ́AmCYƂďo
  if (len mod 8 = 4)then WriteWave;
  NowRendering := FALSE;
  result := TRUE;
end;
//-----------------------------------------------------------
//k`ŕۑ
procedure TCompressWaveData.SaveToFile(filename: string);
begin
  Data.SaveToFile(filename);
end;
//-----------------------------------------------------------
//kf[^Xg[ɏo
procedure TCompressWaveData.SaveToStream(var ss: TmemoryStream);
begin
  Data.SaveToStream(ss);
end;
//-----------------------------------------------------------
//WAVEt@Cǂݍňks
procedure TCompressWaveData.PressFromFile(filename: string);
var
  ss : TMemoryStream;
begin
  if (FileExists(filename) = FALSE)then exit;
  ss := TMemoryStream.Create;
  ss.LoadFromFile(filename);
  PressFromStream(ss);
  ss.Free;
end;
//-----------------------------------------------------------
//kt@Cǂݍ
function TCompressWaveData.LoadFromFile(filename: string):Boolean;
var
  ss : TMemoryStream;
begin
  result := FALSE;
  if (FileExists(filename) = FALSE)then exit;
  ss := TMemoryStream.Create;
  ss.LoadFromFile(filename);
  LoadFromStream(ss);
  ss.Free;
  result := TRUE;
end;
//-----------------------------------------------------------
//Xg[爳kt@Cǂݍ
function TCompressWaveData.LoadFromStream(ss: TMemoryStream):Boolean;
begin
  result := FALSE;
  if (ss = nil)then exit;
  if (data <> nil)then data.Free;
  data := TMemoryStream.Create;
  data.SetSize(ss.Size);
  data.CopyFrom(ss,0);
  //wb_擾
  data.Position := 0;
  data.Read(Hed,sizeof(PRESSWAVEDATAHED));
  FWaveLength := Hed.UnPressSize;
  if (RH <> nil)then RH.Free;
  RH := THuff.Create(data);
  RH.SetCipherCode(CipherCode);
  RH.BeginRead;
  //ĐtȌ
  Stop;
  SetVolume(1.0,0.0);
  result := TRUE;
end;
//-----------------------------------------------------------
//k̔g`ϊe[u𐶐B
//kOɕKsȂƃ_
procedure TCompressWaveData.MakeTable(Vol : Single);
var
  i,aaa : Integer;
begin
  //ϊe[uȂ
  for i:=0 to 127 do
  begin
    Hed.tbl[i*2+0] := +261000;    //őliĂƁ`
    Hed.tbl[i*2+1] := -261000;
  end;
  //ϊe[u̐
  for i:=0 to 126 do
  begin
    aaa :=  round(power(i+2,Vol) * 0.25);
    if (aaa > 261000)then break;
    Hed.tbl[i*2+0] := +aaa;
    Hed.tbl[i*2+1] := -aaa;
  end;
end;

//-----------------------------------------------------------
//{[ݒ肷
procedure TCompressWaveData.SetVolume(vol: single; fade : single);
var
  aaa : single;
begin
  aaa := vol;
  //ʂ臒lݒ
  if (aaa > 1.0)then aaa := 1.0;
  if (aaa < 0.0)then aaa := 0.0;
  //tF[h^CAʂ̑ʂvZ
  if (fade < 0.01)then
  begin           //fadelȌꍇ
    Ffade := 0;
    FVolume := round(aaa*PW_MAXVOLUME);
    FSetVolume := FVolume;
  end
  else
  begin           //fadelꍇ
    Ffade := round(PW_MAXVOLUME / fade / 44100);
    FSetVolume := round(aaa*PW_MAXVOLUME);
  end;
end;
//-----------------------------------------------------------
//tF[hlԂ
function TCompressWaveData.GetFade: single;
begin
  if ((FFade = 0)or(abs(FVolume-FSetVolume) = 0))then
  begin
    result := 0;
    exit;
  end;
  result := (abs(FVolume - FSetVolume)/44100) / FFade;
end;
//-----------------------------------------------------------
//{[lԂ
function TCompressWaveData.GetVolume: single;
begin
  result := FVolume / PW_MAXVOLUME;
end;
//------------------------------------------------------------------------------
//tF[h̉ʂԂ
function TCompressWaveData.GetSetVolume: Single;
begin
  result := FSetVolume / PW_MAXVOLUME;
end;
//------------------------------------------------------------------------------
//ĐԁiʒujԂBPʂsec
function TCompressWaveData.GetPlayTime: Single;
begin
  result := FWavePosition / (44100*4);
end;
//-----------------------------------------------------------
//Ȃ̒ԂBPʂsec
function TCompressWaveData.GetTotalTime: Single;
begin
  result := FWaveLength / (44100*4);
end;
//------------------------------------------------------------------------------
//wb_XV
procedure TCompressWaveData.HedUpdata;
begin
  if (Data = nil)then exit;
  Data.Position := 0;
  Data.Write(hed,sizeof(PRESSWAVEDATAHED));
end;
//-----------------------------------------------------------
//kf[^TDDSDWaveDataɓWJB
function TCompressWaveData.UnPressToDDSD(QS : TDDSD) : TDDSDWavedata;
var
  ss : TMemoryStream;
  buf: TDDSDWavedata;
begin
  result := nil;
  //yf[^̓WJ̈m
  ss := TMemoryStream.Create;
  ss.SetSize(Hed.UnPressSize);
  //kf[^WJ
  Stop;
  Play(FALSE);
  Rendering(ss.Memory,ss.Size);
  Stop;
  //DirectSoundBuffer𐶐ARs[
  buf := TDDSDWavedata.CreateBuffer(QS,44100,16,TRUE,ss.Size);
  if (buf = nil)then exit;
  buf.BlockCopy(0,ss.Memory,ss.Size);
  ss.Free;
  //SoundBufferAhXԂ
  result := buf;
end;
//-----------------------------------------------------------
//kf[^TDDSDWaveDataɓWJB
function TCompressWaveData.UnPressToDDSD3D(QS : TDDSD) : TDDSDWave3D;
var
  ss : TMemoryStream;
  buf: TDDSDWave3D;
begin
  result := nil;
  //yf[^̓WJ̈m
  ss := TMemoryStream.Create;
  ss.SetSize(Hed.UnPressSize);
  //kf[^WJ
  Stop;
  Play(FALSE);
  Rendering(ss.Memory,ss.Size);
  Stop;
  //DirectSoundBuffer𐶐ARs[
  buf := TDDSDWave3D.CreateBuffer(QS,44100,16,ss.Size);
  if (buf = nil)then exit;
  buf.BlockCopy(0,ss.Memory,ss.Size);
  ss.Free;
  //SoundBufferAhXԂ
  result := buf;
end;
//-----------------------------------------------------------
//Đ̒~߁BȂ̐擪ɖ߂
procedure TCompressWaveData.Stop;
begin
  //ĐtOl
  FWavePosition := 0;
  Fvv1 := 0;
  Faa1 := 0;
  Fvv2 := 0;
  Faa2 := 0;
  LBackBuf := 0;
  RBackBuf := 0;
  SetVolume(1.0,0);
  FPlay := FALSE;
  FLoop := 0;

  if (Data = nil)then exit;
  //
  while(NowRendering) do;
  //Jnʒuɖ߂
  RH.MoveBeginPosition;
end;
//-----------------------------------------------------------
//Ȃ̐擪ɖ߂BSTOPƂ̈Ⴂ̓tF[hȂB
procedure TCompressWaveData.Previous;
begin
  //ĐtOl
  FWavePosition := 0;
  Fvv1 := 0;
  Faa1 := 0;
  Fvv2 := 0;
  Faa2 := 0;
  LBackBuf := 0;
  RBackBuf := 0;
  FLoop := 0;

  if (Data = nil)then exit;
  //Jnʒuɖ߂
  RH.MoveBeginPosition;
end;
//------------------------------------------------------------
//Ȃ̍ĐJn
procedure TCompressWaveData.Play(loop:Boolean);
begin
  FPlay    := TRUE;
  FEndLoop := loop;
  if ((FVolume = 0)and(FSetVolume = 0))then SetVolume(1.0,0);
end;

//------------------------------------------------------------
//[vpɃp[^ݒ肵
//--------------------------------------------------------------
//݂̈Ít@C̈ʒuLB
//nt}ɏĂ̂ŁÃtOԂێKv
procedure TCompressWaveData.GetLoopState;
begin
  LPFaa1 := Faa1;
  LPFaa2 := Faa2;
  LPFvv1 := Fvv1;
  LPFvv2 := Fvv2;
  RH.GetPositionData(PosData);
end;
//--------------------------------------------------------------
//LÍt@C̈ʒuɖ߂
procedure TCompressWaveData.SetLoopState;
begin
  Faa1 := LPFaa1;
  Faa2 := LPFaa2;
  Fvv1 := LPFvv1;
  Fvv2 := LPFvv2;
  RH.SetPositionData(PosData);
  FWavePosition := Hed.LoopStart;
end;
//-----------------------------------------------------------
//ÍR[hݒ肷
procedure TCompressWaveData.SetCipherCode(Num: DWORD);
begin
  CipherCode := Num;
end;


//============================================================================
{ TCompressWavePlayer }
//-----------------------------------------------------------
//
constructor TCompressWavePlayer.Create;
var
  i : Integer;
begin
  NowRendering := FALSE;
  FMVolume := PW_MAXVOLUME;
  FMSetVolume := PW_MAXVOLUME;
  FMFade   := 0;
  //SetBufferSize(44100*2 div 2);
  RefreshTime := TimeGetTime;
  for i:=0 to PW_MAXCHANNEL do
  begin
    FMusic[i] := nil;   //o^̈Ӗ
  end;
end;
//------------------------------------------------------------
//
procedure TCompressWavePlayer.Free;
var
  i : Integer;
begin
  if (PrimaryBuffer <> nil)then PrimaryBuffer.Free;
  PrimaryBuffer := nil;
  for i:=0 to PW_MAXCHANNEL do
    if (FBuf[i] <> nil)then FBuf[i].Free;
  Destroy;
end;
//-------------------------------------------------------------
//SȂ~AȂo^ĂȂԂɂ
procedure TCompressWavePlayer.Init;
var
  i : Integer;
begin
  for i:=0 to PW_MAXCHANNEL do Load(i,nil);
end;
//-------------------------------------------------------------
//w`lɋȂo^
procedure TCompressWavePlayer.Load(ch: Integer; Music: TCompressWaveData);
var
  i : Integer;
begin
  if (ch > PW_MAXCHANNEL)then exit;
  if (Music = nil)then
  begin
    Stop(Ch);
    //
    While (NowRendering) do;
    FMusic[ch] := nil;
    exit;
  end;
  //ȃf[^𑽏d悤̂Ȃj炪̂
  //o^ꂽ̂D悳AgpĂ̂͒~
  for i:=0 to PW_MAXCHANNEL do
    if (FMusic[i] = Music)then
    begin
      Stop(i);
      Load(i,nil);
    end;
  //o^
  Stop(Ch);
  Load(Ch,nil);
  //
  While (NowRendering) do;
  FMusic[ch] := Music;
  SetVolume(Ch,1.0,0);
  Stop(Ch);
end;
//-------------------------------------------------------------
//Ȃ~ԂȂĐ
procedure TCompressWavePlayer.Play(ch: Integer; loop:Boolean);
begin
  if (ch > PW_MAXCHANNEL)then exit;
  if (FMusic[ch] = nil)then exit;
  FMusic[ch].Play(loop);
end;
//-------------------------------------------------------------
//o^ꂽȂA_OB
procedure TCompressWavePlayer.Rendering;
var
  i,j,aaa : Integer;
  LVol,RVol : Integer;
  buf : array[0..PW_MAXCHANNEL] of ^TLRWRITEBUFFER;
  Pbuf : ^TLRWRITEBUFFER;
  MixCount : Integer;
begin
  NowRendering := TRUE;
  //O
  if (PrimaryBuffer = nil)then
  begin
    NowRendering := FALSE;
    exit;
  end;
  //}X^[{[0Ȃ烌_OȂ
  if ((FMVolume  < 1)and(FMSetVolume < 1)) then
  begin
    NowRendering := FALSE;
    exit;
  end;
  //o^ĂȂ̂݃_O
  MixCount := 0;
  for i:=0 to PW_MAXCHANNEL do
    if (FMusic[i] <> nil)then
      if (FMusic[i].Rendering(FBuf[i].Memory,BufferSize) = TRUE)then
      begin
        buf[MixCount] := FBuf[i].Memory;
        inc(MixCount);
      end;
  //O
  Pbuf := PrimaryBuffer.Memory;
  //Đ̋Ȃ݂̂
  for i:=0 to BufferSize div 4 - 1 do
  begin
    //_OꂽȂ̂݉Z
    RVol := 0;
    LVol := 0;
    for j:=0 to MixCount-1 do
    begin
      RVol := RVol + Integer(buf[j]^.RBuf);
      LVol := LVol + Integer(buf[j]^.LBuf);
      inc(buf[j]);
    end;
    //
    aaa := FMSetVolume - FMVolume;
    if (abs(aaa) <= FMfade)then
      FMVolume := FMSetVolume
    else
      if (aaa > 0)then FMVolume := FMVolume + FMfade
                  else FMVolume := FMVolume - FMfade;
    aaa := FMVolume shr 20;
    RVol := RVol * aaa div 256;
    LVol := LVol * aaa div 256;
    //OverFlow΍
    if (RVol > +32760)then RVol := +32760;
    if (RVol < -32760)then RVol := -32760;
    if (LVol > +32760)then LVol := +32760;
    if (LVol < -32760)then LVol := -32760;
    Pbuf^.RBuf := SmallInt(RVol);
    Pbuf^.LBuf := SmallInt(LVol);
    inc(PBuf);
  end;
  NowRendering := FALSE;
  RefreshTime := TimeGetTime;
end;
//-------------------------------------------------------------
//_Oobt@̃TCYw肷
procedure TCompressWavePlayer.SetBufferSize(len: DWORD);
var
  i : Integer;
begin
  if (PrimaryBuffer <> nil)then PrimaryBuffer.Free;
  BufferSize := len;
  PrimaryBuffer := TmemoryStream.Create;
  PrimaryBuffer.SetSize(BufferSize);
  for i:=0 to PW_MAXCHANNEL do
  begin
    if (FBuf[i] <> nil)then FBuf[i].Free;
    FBuf[i] := TMemoryStream.Create;
    FBuf[i].SetSize(BufferSize);
  end;
end;
//--------------------------------------------------------------
//}X^[{[ݒ肷
procedure TCompressWavePlayer.SetMasterVolume(vol: single; fade : single);
var
  aaa : single;
begin
  aaa := vol;
  //ʂ臒lݒ
  if (aaa > 1.0)then aaa := 1.0;
  if (aaa < 0.0)then aaa := 0.0;
  //tF[h^CAʂ̑ʂvZ
  if (fade < 0.01)then
  begin           //fadelȌꍇ
    FMfade := 0;
    FMVolume := round(aaa*PW_MAXVOLUME);
    FMSetVolume := FMVolume;
  end
  else
  begin           //fadelꍇ
    FMfade := round(PW_MAXVOLUME / fade / 44100);
    FMSetVolume := round(aaa*PW_MAXVOLUME);
  end;
end;
//--------------------------------------------------------------
//Chɓo^ꂽȂ̃{[ݒ肷
procedure TCompressWavePlayer.SetVolume(ch: Integer; vol: single; fade : single);
begin
  if (ch > PW_MAXCHANNEL)then exit;
  if (FMusic[ch] = nil)then exit;
  FMusic[ch].SetVolume(vol,fade);
end;
//--------------------------------------------------------------
//ChŎw肳ꂽȂ~
procedure TCompressWavePlayer.Stop(ch: Integer);
begin
  if (ch > PW_MAXCHANNEL)then exit;
  if (FMusic[ch] = nil)then exit;
  //
  While (NowRendering) do;
  FMusic[ch].Stop;
end;
//--------------------------------------------------------------
//ChւB
procedure TCompressWavePlayer.Swap(ch1, ch2: Integer);
var
  temp : TCompressWaveData;
begin
  //
  While (NowRendering) do;
  temp := FMusic[ch1];
  FMusic[ch1] := FMusic[ch2];
  FMusic[ch2] := temp;
end;
//------------------------------------------------------------
//_Oꂽobt@̃AhXԂ
function TCompressWavePlayer.Buffer: Pointer;
begin
  if (PrimaryBuffer = nil)then
    begin result := nil; exit; end;
  result := PrimaryBuffer.Memory;
end;
//------------------------------------------------------------------------------
//߂
procedure TCompressWavePlayer.Previous(ch: Integer);
begin
  if (ch > PW_MAXCHANNEL)then exit;
  if (FMusic[ch] = nil)then exit;
  FMusic[ch].Previous;
end;
//------------------------------------------------------------------------------
//ꎞ~
procedure TCompressWaveData.Pause;
begin
  FPlay := FALSE;
end;
//------------------------------------------------------------------------------
//ꎞ~
procedure TCompressWavePlayer.pause(ch: Integer);
begin
  if (ch > PW_MAXCHANNEL)then exit;
  if (FMusic[ch] = nil)then exit;
  FMusic[ch].Pause;
end;
//------------------------------------------------------------------------------
//A[eBXg擾
function TCompressWavePlayer.GetArtist(ch: Integer): String;
begin
  result := 'NoName';
  if (ch > PW_MAXCHANNEL)then exit;
  if (FMusic[ch] = nil)then exit;
  result := FMusic[ch].Hed.MusicArtist;
end;
//------------------------------------------------------------------------------
//tF[hlԂ
function TCompressWavePlayer.GetFade(ch: Integer): single;
begin
  result := 0.0;
  if (ch > PW_MAXCHANNEL)then exit;
  if (FMusic[ch] = nil)then exit;
  result := FMusic[ch].GetFade;
end;
//------------------------------------------------------------------------------
//݂̍ĐԂԂ
function TCompressWavePlayer.GetPlayTime(ch: Integer): Single;
begin
  result := 0.0;
  if (ch > PW_MAXCHANNEL)then exit;
  if (FMusic[ch] = nil)then exit;
  result := FMusic[ch].GetPlayTime;
end;
//------------------------------------------------------------------------------
//Ȃ̒ԂBPʂsec
function TCompressWavePlayer.GetTotalTime(ch: Integer): Single;
begin
  result := 0.0;
  if (ch > PW_MAXCHANNEL)then exit;
  if (FMusic[ch] = nil)then exit;
  result := FMusic[ch].GetTotalTime;
end;
//------------------------------------------------------------------------------
//Ȃ̃^CgԂ
function TCompressWavePlayer.GetTitle(ch: Integer): string;
begin
  result := 'NoENTRY';
  if (ch > PW_MAXCHANNEL)then exit;
  if (FMusic[ch] = nil)then exit;
  result := FMusic[ch].Hed.MusicTitle;
end;
//------------------------------------------------------------------------------
//ʂԂ
function TCompressWavePlayer.GetVolume(ch: Integer): single;
begin
  result := 0.0;
  if (ch > PW_MAXCHANNEL)then exit;
  if (FMusic[ch] = nil)then exit;
  result := FMusic[ch].GetVolume;
end;
//-----------------------------------------------------------
//}X^[̃tF[hlԂ
function TCompressWavePlayer.GetMasterFade: single;
begin
  if ((FMFade = 0)or(abs(FMVolume-FMSetVolume) = 0))then
  begin
    result := 0;
    exit;
  end;
  result := (abs(FMVolume-FMSetVolume)/44100) / FMFade;
end;
//-----------------------------------------------------------
//}X^[̃{[lԂ
function TCompressWavePlayer.GetMasterVolume: single;
begin
  result := FMVolume / PW_MAXVOLUME;
end;

//------------------------------------------------------------------------------
//tF[h̉ʂ𒲂ׂ
function TCompressWavePlayer.GetSetVolume(ch: Integer): single;
begin
  result := 0.0;
  if (ch > PW_MAXCHANNEL)then exit;
  if (FMusic[ch] = nil)then exit;
  result := FMusic[ch].GetSetVolume;
end;

//--------------------------------------------------------------------------------
//̍ĐԂ₤
function TCompressWaveData.GetPlayState: TCWPlayState;
begin
  result := CWStop;
  if (FPlay = TRUE)then
    if (FEndLoop = TRUE)then result := CWLoop
                        else result := CWPlay;
end;

//------------------------------------------------------------------------------
//݂̍ĐԂ₤
function TCompressWavePlayer.GetPlayState(ch: Integer): TCWPlayState;
begin
  result := CWEmpty;
  if (ch > PW_MAXCHANNEL)then exit;
  if (FMusic[ch] = nil)then exit;
  result := FMusic[ch].GetPlayState;
end;
//------------------------------------------------------------------------------
//̉XV܂ł̎
function TCompressWavePlayer.GetReflectTime: Integer;
begin
  result := (BufferSize div 176) * 2 - (TimeGetTime-RefreshTime);
end;

end.
