unit HuffLib;

interface

uses Windows,Classes,Math,SysUtils;

type TNodeState = (nsEmpty,nsBranch,nsLeaf,nsRoot);

//------------------------------------------------------------------------------
//\̐錾
//nt}؍\pm[h\
type THuffTreeNode = record
  Value : BYTE;                        //l(0..255)
  weight: Integer;                     //nt}ؐɎgd݌W
  State : TNodeState;                  //
  Link  : array[0..1] of Integer;      //񕪖ؐ(-1..gp 0..255.gp)
end;
//t@C݂悤wb_
type THuffHedState = record
  HedChar : String[3];                                      //wbh
  Version : Integer;                                        //Version
  HistGraph : array[0..255] of DWORD;                       //o
  FileSize : Int64;                                         //t@CTCY
end;
//Cӂ̏ꏊɔׂ悤ɁiOOjg͐FX
type THuffPositionData = record
  BitBuf   : DWORD;
  BitCount : Integer;
  StreamPos: Int64;
  CipherBuf : DWORD;
end;

//------------------------------------------------------------------------------
//nt}NX
//l0`2551BYTEB
//opx^Ă邱ƂŁAnt}؂𐶐A܂B
type
  THuff = class
  private
    //Ǘ
    Buff : TStream;        // ΏۃXg[
    BeginPos : Int64;      // ̈
    Mode : Integer;
    //rbgo
    IoCount   : Integer;   // 0.. 1..Read 2..Write
    BitBuf    : DWORD;     // ێobt@
    BitCount  : Integer;   // rbgJEg
    BitWriteLen : Int64;   // 񂾃TCY
    CipherBuf : DWORD;
    //nt}
    Node : array [0..511] of THuffTreeNode;                 //؍\
    Code : array [0..255,0..255] of BYTE;                   //Ή\
    Root : Integer;                                         //
    //nt}Írbg
    CipherList : array[0..15] of DWORD;

    //nt}n
    procedure InitHuffTree;                                   //؂
    function  InsertHuffNode(v,w:Integer; s:TNodeState; b1,b2:Integer) : Integer;//؂Ƀm[h̒ǉ
    procedure MakeHuffTree;
    //rbgPʂ̓o͌n
    procedure BeginBitIO;
    procedure EndBitIO;
    function  ReadBit : Integer;
    procedure WriteBit(bit : Integer);

    function  _ROR(src:DWORD; shift:DWORD):DWORD;
  public
    //wbh
    Hed  : THuffHedState;

    constructor Create(buf : TStream);                        // 
    procedure   Free;                                         // ͂̊J
    procedure   SetCipherCode(msk : DWORD);                   // Í}XNrbg
    //ݗp֐
    procedure   BeginWrite(hst : array of DWORD);             // ݂̃X^[g
    procedure   Write(vol : Integer);                         // 8Bito
    procedure   SetFileSize(s : Int64);                       // ÕTCYݒ
    //ǂݍݗp֐
    procedure   BeginRead;                                    // Xg[؍\𐶐
    function    Read : Integer;                               // 8Bito
    function    GetFileSize : Int64;                          // ÕTCY擾
    function    GetEOF : Boolean;                             // EOFo
    procedure   MoveBeginPosition;                            // ŏ̈ʒuɖ߂
    procedure   GetPositionData(var s : THuffPositionData);   // q~c
    procedure   SetPositionData(    s : THuffPositionData);
end;

implementation

//------------------------------------------------------------------------------
//
//w肷BufTStreamnŁAeʂɂĎOTMemoryStream/TFileStreamȂǂ𐶐邱
//݁Eǂݍ݂݂͌TStream.Position̈ʒusB
//íAf[^𕄍ĕۑꍇȂǂlʁj
constructor THuff.Create(buf : TStream);
begin
  //Xg[`
  Buff := buf;
  //ݒ
  InitHuffTree;
  Hed.HedChar := 'HUF';
  Hed.Version := 1;
  Hed.FileSize:= 0;
  //Írbgݒ
  CipherBuf := 0;
  SetCipherCode($0);
  //[h
  mode := 0;
end;

//------------------------------------------------------------------------------
//J
procedure   THuff.Free;
begin
  if (mode = 2)then EndBitIo;
  destroy;
end;

//------------------------------------------------------------------------------
//؍\igpԁjɂ
procedure   THuff.InitHuffTree;
var
  i : Integer;
begin
  for i:=0 to 511 do Node[i].State := nsEMPTY;
end;

//------------------------------------------------------------------------------
//nt}؂Ƀm[hǉ
function THuff.InsertHuffNode(v,w:Integer; s:TNodeState; b1,b2:Integer) : Integer;
var
  i : Integer;
begin
  i := 0;
  while ((Node[i].State <> nsEMPTY)and(i<512)) do inc(i);
  if (i = 512)then
  begin
    result := -1;
    exit;
    //halt;
  end;
  Node[i].Value := BYTE(v);
  Node[i].Weight := w;
  Node[i].State  := s;
  Node[i].Link[0] := b1;
  if (Node[i].Link[0] > 511)then halt;
  Node[i].Link[1] := b2;
  if (Node[i].Link[1] > 511)then halt;
  //o^ԍԂ
  result := i;
end;

//------------------------------------------------------------------------------
//nt}ꂽf[^ǂݍœWJ
function Thuff.Read : Integer;
var
  i : Integer;
begin
  i := Root;
  while (Node[i].State <> nsLeaf)do i := Node[i].Link[ReadBit];
  result := Node[i].Value;
end;

//------------------------------------------------------------------------------
//f[^nt}ďo
procedure THuff.Write(vol: Integer);
var
  i : Integer;
begin
  i := 0;
  while (Code[vol,i] <> $FF) do
  begin
    WriteBit(Code[vol,i]);
    inc(i);
  end;
end;

//------------------------------------------------------------------------------
//oz\iarray[0..255] of BYTEjnt}؁ER[h𐶐
procedure THuff.MakeHuffTree;
var
  i,aa1,aa2,aa3 : Integer;
  tCodePos : Integer;
  tCode1,tCode2 : array [0..256] of BYTE;
  tNode : array[0..256] of Integer;
  //ŏ̏d݂m[h
  function SerchMinNode : Integer;
  var
    ii,aaa1,aaa2 : Integer;
  begin
    aaa1 := $FFFFFFF;
    aaa2 := 0;
    for ii:=0 to 255 do
      if (tNode[ii] <> -1)then
        if (Node[tNode[ii]].Weight < aaa1)then
        begin
          aaa2 := ii;
          aaa1 := Node[tNode[ii]].Weight;
        end;
    result := aaa2;
  end;
  //Ƃ߂lm[h
  function SerchNearNode(pos : Integer) : Integer;
  var
    ii,aaa1,aaa2 : Integer;
  begin
    aaa1 := $FFFFFFF;
    aaa2 := 0;
    for ii:=0 to 255 do
      if (tNode[ii] <> -1)then
        if ((abs(Node[tNode[ii]].Weight - Node[tNode[pos]].Weight) < aaa1)and
            (pos <> ii))then
        begin
          aaa2 := ii;
          aaa1 := Node[tNode[ii]].Weight;
        end;
    result := aaa2;
  end;
  //R[h\؂琶
  procedure MakeHuffCodeFromTree(pos : Integer);
  var
    ii,aaa1 : Integer;
  begin
    if (Node[pos].State = nsLeaf)then
    begin          //݂
      tCode1[tCodePos] := $FF;
      aaa1 := Node[pos].Value;
      for ii:=0 to 255 do Code[aaa1,ii] := tCode1[ii];
    end
    else
    begin          //Ⴄ
      if (Node[pos].Link[0] <> -1)then
      begin
        tCode1[tCodePos] := 0;
        inc(tCodePos);
        MakeHuffCodeFromTree(Node[pos].Link[0]);
      end;
      if (Node[pos].Link[1] <> -1)then
      begin
        tCode1[tCodePos] := 1;
        inc(tCodePos);
        MakeHuffCodeFromTree(Node[pos].Link[1]);
      end;
    end;
    dec(tCodePos);
  end;
begin
  //nt}؂̏
  InitHuffTree;
  for i:=0 to 255 do
  begin
    tNode[i] := -1;
    tCode1[i] := 0;
    tCode2[i] := 0;
  end;
  //q̃m[hǉArΏۂɂB
  for i:=0 to 255 do
    tNode[i] := InsertHuffNode(i,Hed.HistGraph[i],nsLeaf,-1,-1);
  //œK؂𐶐
  for i:=0 to 255-1 do
  begin
    //łm[h݂
    aa1 := SerchMinNode;
    //łm[hɍł߂lm[hT
    aa2 := SerchNearNode(aa1);
    //qVȃm[h𐶐
    aa3 := InsertHuffNode(-1,Node[tNode[aa1]].Weight+Node[tNode[aa2]].Weight,nsBranch,tNode[aa1],tNode[aa2]);
    //rΏۃm[haa1,aa2菜B
    tNode[aa1] := -1;
    tNode[aa2] := -1;
    //Vɐm[hrΏۂɒǉ
    tNode[aa1] := aa3;
  end;
  //Ōɒǉm[h؂̒_ɂȂ
  Root := aa3;

  //؏񂩂f[^WJpX^bN𐶐
  tCodePos := 0;
  MakeHuffCodeFromTree(Root);
end;

//------------------------------------------------------------------------------
//rbgo͂̊Jn
procedure THuff.BeginBitIO;
begin
  IoCount := 0;
  BitBuf := 0;
  BitCount := 32;
  BitWriteLen := 0;
  CipherBuf := 0;
end;

//------------------------------------------------------------------------------
//rbgo͂̏I
procedure THuff.EndBitIO;
begin
  if ((IoCount = 2)and(BitCount > 0))then
  begin
    BitBuf := BitBuf xor CipherBuf;
    Buff.Write(BitBuf,4);
  end;
  BeginBitIo;
end;

//------------------------------------------------------------------------------
//t@C1Bitǂݍ
function THuff.ReadBit : Integer;
var
  aaa : DWORD;
begin
  //ǂݍ
  if (BitCount = 32)then
  begin
    IoCount := 1; //ReadMode
    if (Buff.Position < Buff.Size)then
    begin
      //ǂݍ
      Buff.Read(aaa,sizeof(DWORD));
      BitBuf := aaa xor CipherBuf;
      //ÍtF[Y
      CipherBuf := _ROR(CipherBuf,aaa and 7);
      CipherBuf := CipherBuf xor CipherList[aaa and 7];
    end;
    BitCount := 0;
  end;
  //1BitԂi
  result := BitBuf and 1;
  BitBuf := BitBuf shr 1;
  //BitCounti߂
  inc(BitCount);
end;

//------------------------------------------------------------------------------
//t@C1Bit`
procedure THuff.WriteBit(bit: Integer);
var
  aaa : DWORD;
begin
  //ݒtOĂ邩H
  if (IoCount = 0)then
  begin
    IoCount := 2;  //WriteMode
    BitCount := 0;
  end;
  //1Biti[
  BitBuf := BitBuf or ((DWORD(bit) and 1) shl BitCount);
  inc(BitCount);
  //`
  if (BitCount = 32)then
  begin
    //`
    aaa := BitBuf xor CipherBuf;
    Buff.Write(aaa,4);
    //ÍtF[Y
    CipherBuf := _ROR(CipherBuf,aaa and 7);
    CipherBuf := CipherBuf xor CipherList[aaa and 7];
    //l̃Zbg
    BitCount := 0;
    BitBuf := 0;
    inc(BitWriteLen,4);
  end;
end;

//------------------------------------------------------------------------------
//Xg[畄̓ǂݍ݂Jn܂
procedure THuff.BeginRead;
begin
  Buff.Read(Hed,sizeof(THuffHedState));
  MakeHuffTree;
  BeginPos := Buff.Position;
  BeginbitIo;
  Mode := 1;
end;

//------------------------------------------------------------------------------
//nt}Jn܂
procedure THuff.BeginWrite(hst: array of DWORD);
var
  i : Integer;
begin
  for i:=0 to 255 do
    Hed.HistGraph[i] := hst[i];
  MakeHuffTree;
  Buff.Write(Hed,sizeof(THuffHedState));
  BeginBitIo;
  Mode := 2;
end;

//------------------------------------------------------------------------------
//Õt@CTCY擾
function THuff.GetFileSize: Int64;
begin
  result := Hed.FileSize;
end;

//------------------------------------------------------------------------------
//Õt@CTCYݒ
//ł͂Ȃ̂ŁAꂽȂ΂ȂĂOK
procedure THuff.SetFileSize(s: Int64);
begin
  Hed.FileSize := s;
end;

//------------------------------------------------------------------------------
//EOFo
function THuff.GetEOF: Boolean;
begin
  if (Buff.Position < Buff.Size)then result := FALSE
                                else result := TRUE;
end;

//------------------------------------------------------------------------------
//ŏ̈ʒuɖ߂
procedure THuff.MoveBeginPosition;
begin
  EndBitIo;
  Buff.Position := BeginPos;
  BeginBitIo;
end;

//------------------------------------------------------------------------------
procedure THuff.GetPositionData(var s: THuffPositionData);
begin
  s.BitBuf    := BitBuf;
  s.BitCount  := BitCount;
  s.StreamPos := Buff.Position;
  s.CipherBuf := CipherBuf;
end;

//------------------------------------------------------------------------------
procedure THuff.SetPositionData(s: THuffPositionData);
begin
  BitBuf   := s.BitBuf;
  BitCount := s.BitCount;
  Buff.Position := s.StreamPos;
  CipherBuf := s.CipherBuf;  
end;

//------------------------------------------------------------------------------
procedure THuff.SetCipherCode(msk: DWORD);
begin
  //}XNXg𐶐
  CipherList[0] := msk div 3;
  CipherList[1] := msk div 17;
  CipherList[2] := msk div 7;
  CipherList[3] := msk div 5;
  CipherList[4] := msk div 3;
  CipherList[5] := msk div 11;
  CipherList[6] := msk div 13;
  CipherList[7] := msk div 19;
end;

//------------------------------------------------------------------------------
function THuff._ROR(src: DWORD; shift: DWORD): DWORD;
begin
  asm
    push eax;
    push ecx;
    mov eax,src;
    mov ecx,shift;
    ror eax,cl;
    mov result,eax;
    pop ecx;
    pop eax;
  end;
end;

end.
